/* PulseAudioManager.c generated by valac 0.40.7, the Vala compiler
 * generated from PulseAudioManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/*
 * Vocabulary of PulseAudio:
 *  - Source: Input (microphone)
 *  - Sink: Output (speaker)
 */


#include <glib.h>
#include <glib-object.h>
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "pulse/ext-stream-restore.h"
#include <float.h>
#include <math.h>


#define SOUND_TYPE_PULSE_AUDIO_MANAGER (sound_pulse_audio_manager_get_type ())
#define SOUND_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager))
#define SOUND_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))
#define SOUND_IS_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_IS_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_PULSE_AUDIO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))

typedef struct _SoundPulseAudioManager SoundPulseAudioManager;
typedef struct _SoundPulseAudioManagerClass SoundPulseAudioManagerClass;
typedef struct _SoundPulseAudioManagerPrivate SoundPulseAudioManagerPrivate;

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_0_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES
};
static GParamSpec* sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _pa_glib_mainloop_free0(var) ((var == NULL) ? NULL : (var = (pa_glib_mainloop_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _SoundDevicePrivate SoundDevicePrivate;
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
typedef struct _SoundPulseAudioManagerReconnectToPulseData SoundPulseAudioManagerReconnectToPulseData;
typedef struct _Block2Data Block2Data;

#define SOUND_DEVICE_TYPE_PORT (sound_device_port_get_type ())
#define SOUND_DEVICE_PORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_DEVICE_TYPE_PORT, SoundDevicePort))
#define SOUND_DEVICE_PORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_DEVICE_TYPE_PORT, SoundDevicePortClass))
#define SOUND_DEVICE_IS_PORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_DEVICE_TYPE_PORT))
#define SOUND_DEVICE_IS_PORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_DEVICE_TYPE_PORT))
#define SOUND_DEVICE_PORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_DEVICE_TYPE_PORT, SoundDevicePortClass))

typedef struct _SoundDevicePort SoundDevicePort;
typedef struct _SoundDevicePortClass SoundDevicePortClass;
typedef struct _SoundDevicePortPrivate SoundDevicePortPrivate;
#define _sound_device_port_unref0(var) ((var == NULL) ? NULL : (var = (sound_device_port_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL,
	SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS
};
static guint sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS] = {0};

struct _SoundPulseAudioManager {
	GObject parent_instance;
	SoundPulseAudioManagerPrivate * priv;
};

struct _SoundPulseAudioManagerClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerPrivate {
	pa_context* _context;
	pa_glib_mainloop* loop;
	gboolean is_ready;
	guint reconnect_timer_id;
	GeeHashMap* input_devices;
	GeeHashMap* output_devices;
	SoundDevice* _default_output;
	SoundDevice* _default_input;
	gchar* default_source_name;
	gchar* default_sink_name;
	GeeHashMap* volume_operations;
};

struct _Block1Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _SoundDevice {
	GObject parent_instance;
	SoundDevicePrivate * priv;
	GeeLinkedList* volume_operations;
};

struct _SoundDeviceClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerReconnectToPulseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	gboolean _tmp0_;
	pa_context* _tmp1_;
	pa_proplist* props;
	pa_proplist* _tmp2_;
	pa_proplist* _tmp3_;
	pa_glib_mainloop* _tmp4_;
	pa_mainloop_api* _tmp5_;
	pa_proplist* _tmp6_;
	pa_context* _tmp7_;
	pa_context* _tmp8_;
	pa_context* _tmp9_;
	pa_context* _tmp10_;
	pa_context* _tmp11_;
	const gchar* _tmp12_;
};

struct _Block2Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _SoundDevicePort {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SoundDevicePortPrivate * priv;
	gchar* name;
	gchar* description;
	guint32 priority;
};

struct _SoundDevicePortClass {
	GTypeClass parent_class;
	void (*finalize) (SoundDevicePort *self);
};

struct _Block3Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};


static gpointer sound_pulse_audio_manager_parent_class = NULL;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam = NULL;

GType sound_pulse_audio_manager_get_type (void) G_GNUC_CONST;
GType sound_device_get_type (void) G_GNUC_CONST;
#define SOUND_PULSE_AUDIO_MANAGER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerPrivate))
SoundPulseAudioManager* sound_pulse_audio_manager_get_default (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_new (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_construct (GType object_type);
void sound_pulse_audio_manager_start (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
void sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                                   SoundDevice* device);
gboolean sound_device_get_input (SoundDevice* self);
const gchar* sound_device_get_name (SoundDevice* self);
pa_context* sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                        pa_context* c,
                                                                        pa_ext_stream_restore_info* info,
                                                                        gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                                pa_ext_stream_restore_info* info,
                                                                                                                gint eol,
                                                                                                                gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                      pa_context* c,
                                                                      pa_ext_stream_restore_info* info,
                                                                      gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                              pa_ext_stream_restore_info* info,
                                                                                                              gint eol,
                                                                                                              gpointer self);
void sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self,
                                                   SoundDevice* device,
                                                   gboolean mute);
guint32 sound_device_get_index (SoundDevice* self);
void sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self,
                                                     SoundDevice* device,
                                                     gdouble volume);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block1Data* _data1_,
                     pa_operation* operation);
static gboolean ___lambda7__gee_forall_func (gpointer g,
                                      gpointer self);
void sound_device_get_cvolume (SoundDevice* self,
                               pa_cvolume * result);
static pa_volume_t sound_pulse_audio_manager_double_to_volume (gdouble vol);
void sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self,
                                                      SoundDevice* device,
                                                      gfloat balance);
void sound_device_get_channel_map (SoundDevice* self,
                                   pa_channel_map * result);
static gboolean sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data);
static void sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper (GObject *source_object,
                                                                       GAsyncResult *res,
                                                                       void *user_data);
static gboolean sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_);
static void sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self,
                                            pa_context* value);
static void sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                       pa_context* c);
static void _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                               gpointer self);
static void sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_subscription_event_type_t t,
                                                   guint32 index);
static void _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                              pa_subscription_event_type_t t,
                                                                              guint32 idx,
                                                                              gpointer self);
static void sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* c,
                                                     pa_server_info* i);
static void _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                          pa_server_info* i,
                                                                          gpointer self);
static gboolean _sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self);
static void sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_sink_info* i,
                                                   gint eol);
static void _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                      pa_sink_info* i,
                                                                      gint eol,
                                                                      gpointer self);
static void sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* c,
                                                     pa_source_info* i,
                                                     gint eol);
static void _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                          pa_source_info* i,
                                                                          gint eol,
                                                                          gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
SoundDevice* sound_device_new (guint32 index);
SoundDevice* sound_device_construct (GType object_type,
                                     guint32 index);
void sound_device_set_input (SoundDevice* self,
                             gboolean value);
void sound_device_set_name (SoundDevice* self,
                            const gchar* value);
void sound_device_set_display_name (SoundDevice* self,
                                    const gchar* value);
void sound_device_set_is_muted (SoundDevice* self,
                                gboolean value);
void sound_device_set_cvolume (SoundDevice* self,
                               pa_cvolume * value);
void sound_device_set_channel_map (SoundDevice* self,
                                   pa_channel_map * value);
void sound_device_set_balance (SoundDevice* self,
                               gfloat value);
static gboolean __lambda6_ (Block2Data* _data2_,
                     pa_operation* operation);
static gboolean ___lambda6__gee_forall_func (gpointer g,
                                      gpointer self);
gpointer sound_device_port_ref (gpointer instance);
void sound_device_port_unref (gpointer instance);
GParamSpec* sound_device_param_spec_port (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void sound_device_value_set_port (GValue* value,
                                  gpointer v_object);
void sound_device_value_take_port (GValue* value,
                                   gpointer v_object);
gpointer sound_device_value_get_port (const GValue* value);
GType sound_device_port_get_type (void) G_GNUC_CONST;
GeeArrayList* sound_device_get_ports (SoundDevice* self);
void sound_device_set_default_port (SoundDevice* self,
                                    SoundDevicePort* value);
SoundDevicePort* sound_device_port_new (void);
SoundDevicePort* sound_device_port_construct (GType object_type);
static gdouble sound_pulse_audio_manager_volume_to_double (pa_volume_t vol);
void sound_device_set_volume (SoundDevice* self,
                              gdouble value);
void sound_device_set_form_factor (SoundDevice* self,
                                   const gchar* value);
void sound_device_set_is_default (SoundDevice* self,
                                  gboolean value);
gboolean sound_device_get_is_default (SoundDevice* self);
static void sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                                  SoundDevice* value);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block3Data* _data3_,
                     pa_operation* operation);
static gboolean ___lambda5__gee_forall_func (gpointer g,
                                      gpointer self);
static void sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                                   SoundDevice* value);
SoundDevice* sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self);
SoundDevice* sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self);
static GObject * sound_pulse_audio_manager_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void sound_pulse_audio_manager_finalize (GObject * obj);
static void _vala_sound_pulse_audio_manager_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_sound_pulse_audio_manager_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);


SoundPulseAudioManager*
sound_pulse_audio_manager_get_default (void)
{
	SoundPulseAudioManager* result = NULL;
	SoundPulseAudioManager* _tmp0_;
	SoundPulseAudioManager* _tmp2_;
	_tmp0_ = sound_pulse_audio_manager_pam;
	if (_tmp0_ == NULL) {
		SoundPulseAudioManager* _tmp1_;
		_tmp1_ = sound_pulse_audio_manager_new ();
		_g_object_unref0 (sound_pulse_audio_manager_pam);
		sound_pulse_audio_manager_pam = _tmp1_;
	}
	_tmp2_ = sound_pulse_audio_manager_pam;
	result = _tmp2_;
	return result;
}


static SoundPulseAudioManager*
sound_pulse_audio_manager_construct (GType object_type)
{
	SoundPulseAudioManager * self = NULL;
	self = (SoundPulseAudioManager*) g_object_new (object_type, NULL);
	return self;
}


static SoundPulseAudioManager*
sound_pulse_audio_manager_new (void)
{
	return sound_pulse_audio_manager_construct (SOUND_TYPE_PULSE_AUDIO_MANAGER);
}


void
sound_pulse_audio_manager_start (SoundPulseAudioManager* self)
{
	g_return_if_fail (self != NULL);
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
}


static void
_sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                           pa_ext_stream_restore_info* info,
                                                                                                           gint eol,
                                                                                                           gpointer self)
{
	sound_pulse_audio_manager_ext_stream_restore_read_source_callback ((SoundPulseAudioManager*) self, c, info, eol);
}


static void
_sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                         pa_ext_stream_restore_info* info,
                                                                                                         gint eol,
                                                                                                         gpointer self)
{
	sound_pulse_audio_manager_ext_stream_restore_read_sink_callback ((SoundPulseAudioManager*) self, c, info, eol);
}


void
sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                              SoundDevice* device)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = sound_device_get_input (device);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		pa_operation* ope = NULL;
		pa_context* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		pa_operation* _tmp8_;
		pa_operation* _tmp9_;
		_tmp2_ = sound_device_get_name (device);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_strdup (_tmp3_);
		_g_free0 (self->priv->default_source_name);
		self->priv->default_source_name = _tmp4_;
		_tmp5_ = self->priv->_context;
		_tmp6_ = sound_device_get_name (device);
		_tmp7_ = _tmp6_;
		_tmp8_ = pa_context_set_default_source (_tmp5_, _tmp7_, NULL, NULL);
		ope = _tmp8_;
		_tmp9_ = ope;
		if (_tmp9_ != NULL) {
			pa_context* _tmp10_;
			pa_operation* _tmp11_;
			pa_operation* _tmp12_;
			_tmp10_ = self->priv->_context;
			_tmp11_ = pa_ext_stream_restore_read (_tmp10_, _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb, self);
			_tmp12_ = _tmp11_;
			_pa_operation_unref0 (_tmp12_);
		}
		_pa_operation_unref0 (ope);
	} else {
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		pa_operation* ope = NULL;
		pa_context* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		pa_operation* _tmp19_;
		pa_operation* _tmp20_;
		_tmp13_ = sound_device_get_name (device);
		_tmp14_ = _tmp13_;
		_tmp15_ = g_strdup (_tmp14_);
		_g_free0 (self->priv->default_sink_name);
		self->priv->default_sink_name = _tmp15_;
		_tmp16_ = self->priv->_context;
		_tmp17_ = sound_device_get_name (device);
		_tmp18_ = _tmp17_;
		_tmp19_ = pa_context_set_default_sink (_tmp16_, _tmp18_, NULL, NULL);
		ope = _tmp19_;
		_tmp20_ = ope;
		if (_tmp20_ != NULL) {
			pa_context* _tmp21_;
			pa_operation* _tmp22_;
			pa_operation* _tmp23_;
			_tmp21_ = self->priv->_context;
			_tmp22_ = pa_ext_stream_restore_read (_tmp21_, _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb, self);
			_tmp23_ = _tmp22_;
			_pa_operation_unref0 (_tmp23_);
		}
		_pa_operation_unref0 (ope);
	}
}


void
sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self,
                                              SoundDevice* device,
                                              gboolean mute)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_tmp0_ = sound_device_get_input (device);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		pa_context* _tmp2_;
		guint32 _tmp3_;
		guint32 _tmp4_;
		pa_operation* _tmp5_;
		pa_operation* _tmp6_;
		_tmp2_ = self->priv->_context;
		_tmp3_ = sound_device_get_index (device);
		_tmp4_ = _tmp3_;
		_tmp5_ = pa_context_set_source_mute_by_index (_tmp2_, _tmp4_, mute, NULL, NULL);
		_tmp6_ = _tmp5_;
		_pa_operation_unref0 (_tmp6_);
	} else {
		pa_context* _tmp7_;
		guint32 _tmp8_;
		guint32 _tmp9_;
		pa_operation* _tmp10_;
		pa_operation* _tmp11_;
		_tmp7_ = self->priv->_context;
		_tmp8_ = sound_device_get_index (device);
		_tmp9_ = _tmp8_;
		_tmp10_ = pa_context_set_sink_mute_by_index (_tmp7_, _tmp9_, mute, NULL, NULL);
		_tmp11_ = _tmp10_;
		_pa_operation_unref0 (_tmp11_);
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->device);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}


static gboolean
__lambda7_ (Block1Data* _data1_,
            pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
	GeeLinkedList* _tmp0_;
	self = _data1_->self;
	g_return_val_if_fail (operation != NULL, FALSE);
	if (pa_operation_get_state (operation) == PA_OPERATION_RUNNING) {
		pa_operation_cancel (operation);
	}
	_tmp0_ = _data1_->device->volume_operations;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, operation);
	result = G_SOURCE_CONTINUE;
	_pa_operation_unref0 (operation);
	return result;
}


static gboolean
___lambda7__gee_forall_func (gpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda7_ (self, (pa_operation*) g);
	return result;
}


void
sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self,
                                                SoundDevice* device,
                                                gdouble volume)
{
	Block1Data* _data1_;
	SoundDevice* _tmp0_;
	GeeLinkedList* _tmp1_;
	pa_cvolume cvol = {0};
	pa_cvolume _tmp2_ = {0};
	pa_cvolume _tmp3_;
	pa_operation* operation = NULL;
	gboolean _tmp4_;
	gboolean _tmp5_;
	pa_operation* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (device);
	_g_object_unref0 (_data1_->device);
	_data1_->device = _tmp0_;
	_tmp1_ = _data1_->device->volume_operations;
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp1_, ___lambda7__gee_forall_func, _data1_);
	sound_device_get_cvolume (_data1_->device, &_tmp2_);
	_tmp3_ = _tmp2_;
	cvol = _tmp3_;
	pa_cvolume_scale (&cvol, sound_pulse_audio_manager_double_to_volume (volume));
	operation = NULL;
	_tmp4_ = sound_device_get_input (_data1_->device);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		pa_context* _tmp6_;
		guint32 _tmp7_;
		guint32 _tmp8_;
		pa_cvolume _tmp9_;
		pa_operation* _tmp10_;
		_tmp6_ = self->priv->_context;
		_tmp7_ = sound_device_get_index (_data1_->device);
		_tmp8_ = _tmp7_;
		_tmp9_ = cvol;
		_tmp10_ = pa_context_set_source_volume_by_index (_tmp6_, _tmp8_, &_tmp9_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp10_;
	} else {
		pa_context* _tmp11_;
		guint32 _tmp12_;
		guint32 _tmp13_;
		pa_cvolume _tmp14_;
		pa_operation* _tmp15_;
		_tmp11_ = self->priv->_context;
		_tmp12_ = sound_device_get_index (_data1_->device);
		_tmp13_ = _tmp12_;
		_tmp14_ = cvol;
		_tmp15_ = pa_context_set_sink_volume_by_index (_tmp11_, _tmp13_, &_tmp14_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp15_;
	}
	_tmp16_ = operation;
	if (_tmp16_ != NULL) {
		GeeLinkedList* _tmp17_;
		pa_operation* _tmp18_;
		_tmp17_ = _data1_->device->volume_operations;
		_tmp18_ = operation;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
	}
	_pa_operation_unref0 (operation);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}


void
sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self,
                                                 SoundDevice* device,
                                                 gfloat balance)
{
	pa_cvolume cvol = {0};
	pa_cvolume _tmp0_ = {0};
	pa_cvolume _tmp1_;
	pa_channel_map _tmp2_ = {0};
	pa_channel_map _tmp3_;
	pa_operation* operation = NULL;
	gboolean _tmp4_;
	gboolean _tmp5_;
	pa_operation* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (device != NULL);
	sound_device_get_cvolume (device, &_tmp0_);
	_tmp1_ = _tmp0_;
	cvol = _tmp1_;
	sound_device_get_channel_map (device, &_tmp2_);
	_tmp3_ = _tmp2_;
	cvol = *pa_cvolume_set_balance (&cvol, &_tmp3_, balance);
	operation = NULL;
	_tmp4_ = sound_device_get_input (device);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		pa_context* _tmp6_;
		guint32 _tmp7_;
		guint32 _tmp8_;
		pa_cvolume _tmp9_;
		pa_operation* _tmp10_;
		_tmp6_ = self->priv->_context;
		_tmp7_ = sound_device_get_index (device);
		_tmp8_ = _tmp7_;
		_tmp9_ = cvol;
		_tmp10_ = pa_context_set_source_volume_by_index (_tmp6_, _tmp8_, &_tmp9_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp10_;
	} else {
		pa_context* _tmp11_;
		guint32 _tmp12_;
		guint32 _tmp13_;
		pa_cvolume _tmp14_;
		pa_operation* _tmp15_;
		_tmp11_ = self->priv->_context;
		_tmp12_ = sound_device_get_index (device);
		_tmp13_ = _tmp12_;
		_tmp14_ = cvol;
		_tmp15_ = pa_context_set_sink_volume_by_index (_tmp11_, _tmp13_, &_tmp14_, NULL, NULL);
		_pa_operation_unref0 (operation);
		operation = _tmp15_;
	}
	_tmp16_ = operation;
	if (_tmp16_ != NULL) {
		GeeLinkedList* _tmp17_;
		pa_operation* _tmp18_;
		_tmp17_ = device->volume_operations;
		_tmp18_ = operation;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
	}
	_pa_operation_unref0 (operation);
}


static gboolean
sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->reconnect_timer_id = 0U;
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
	result = FALSE;
	return result;
}


static void
sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (SoundPulseAudioManagerReconnectToPulseData, _data_);
}


static void
sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper (GObject *source_object,
                                                                  GAsyncResult *res,
                                                                  void *user_data)
{
	SoundPulseAudioManagerReconnectToPulseData* _task_data_;
	_task_data_ = g_task_get_task_data (G_TASK (res));
	if (_task_data_->_callback_ != NULL) {
		_task_data_->_callback_ (source_object, res, user_data);
	}
	_task_data_->_task_complete_ = TRUE;
}


static void
sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	SoundPulseAudioManager* _tmp0_;
	_data_ = g_slice_new0 (SoundPulseAudioManagerReconnectToPulseData);
	_data_->_callback_ = _callback_;
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper, _user_data_);
	if (_callback_ == NULL) {
		_data_->_task_complete_ = TRUE;
	}
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_reconnect_to_pulse_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	sound_pulse_audio_manager_reconnect_to_pulse_co (_data_);
}


static void
sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}


static void
_sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                          gpointer self)
{
	sound_pulse_audio_manager_context_state_callback ((SoundPulseAudioManager*) self, c);
}


static gboolean
sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->is_ready;
	if (_data_->_tmp0_) {
		_data_->_tmp1_ = _data_->self->priv->_context;
		pa_context_disconnect (_data_->_tmp1_);
		sound_pulse_audio_manager_set_context (_data_->self, NULL);
		_data_->self->priv->is_ready = FALSE;
	}
	_data_->_tmp2_ = pa_proplist_new ();
	_data_->props = _data_->_tmp2_;
	_data_->_tmp3_ = _data_->props;
	pa_proplist_sets (_data_->_tmp3_, PA_PROP_APPLICATION_ID, "org.pantheon.switchboard.plug.sound");
	_data_->_tmp4_ = _data_->self->priv->loop;
	_data_->_tmp5_ = pa_glib_mainloop_get_api (_data_->_tmp4_);
	_data_->_tmp6_ = _data_->props;
	_data_->_tmp7_ = pa_context_new_with_proplist (_data_->_tmp5_, NULL, _data_->_tmp6_);
	_data_->_tmp8_ = _data_->_tmp7_;
	sound_pulse_audio_manager_set_context (_data_->self, _data_->_tmp8_);
	_pa_context_unref0 (_data_->_tmp8_);
	_data_->_tmp9_ = _data_->self->priv->_context;
	pa_context_set_state_callback (_data_->_tmp9_, _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t, _data_->self);
	_data_->_tmp10_ = _data_->self->priv->_context;
	if (pa_context_connect (_data_->_tmp10_, NULL, PA_CONTEXT_NOFAIL, NULL) < 0) {
		_data_->_tmp11_ = _data_->self->priv->_context;
		_data_->_tmp12_ = pa_strerror (pa_context_errno (_data_->_tmp11_));
		g_warning ("PulseAudioManager.vala:154: pa_context_connect() failed: %s\n", _data_->_tmp12_);
	}
	_pa_proplist_free0 (_data_->props);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (_data_->_task_complete_ != TRUE) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void
_sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                         pa_subscription_event_type_t t,
                                                                         guint32 idx,
                                                                         gpointer self)
{
	sound_pulse_audio_manager_subscribe_callback ((SoundPulseAudioManager*) self, c, t, idx);
}


static void
_sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                     pa_server_info* i,
                                                                     gpointer self)
{
	sound_pulse_audio_manager_server_info_callback ((SoundPulseAudioManager*) self, c, i);
}


static gboolean
_sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = sound_pulse_audio_manager_reconnect_timeout ((SoundPulseAudioManager*) self);
	return result;
}


static void
sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                  pa_context* c)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	switch (pa_context_get_state (c)) {
		case PA_CONTEXT_READY:
		{
			pa_operation* _tmp0_;
			pa_operation* _tmp1_;
			pa_context* _tmp2_;
			pa_operation* _tmp3_;
			pa_operation* _tmp4_;
			pa_context_set_subscribe_callback (c, _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t, self);
			_tmp0_ = pa_context_subscribe (c, (((PA_SUBSCRIPTION_MASK_SERVER | PA_SUBSCRIPTION_MASK_SINK) | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SINK_INPUT) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT, NULL, NULL);
			_tmp1_ = _tmp0_;
			_pa_operation_unref0 (_tmp1_);
			_tmp2_ = self->priv->_context;
			_tmp3_ = pa_context_get_server_info (_tmp2_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
			_tmp4_ = _tmp3_;
			_pa_operation_unref0 (_tmp4_);
			self->priv->is_ready = TRUE;
			break;
		}
		case PA_CONTEXT_FAILED:
		case PA_CONTEXT_TERMINATED:
		{
			guint _tmp5_;
			_tmp5_ = self->priv->reconnect_timer_id;
			if (_tmp5_ == 0U) {
				self->priv->reconnect_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _sound_pulse_audio_manager_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
			}
			break;
		}
		default:
		{
			self->priv->is_ready = FALSE;
			break;
		}
	}
}


static void
_sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                 pa_sink_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
	sound_pulse_audio_manager_sink_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
}


static void
_sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                     pa_source_info* i,
                                                                     gint eol,
                                                                     gpointer self)
{
	sound_pulse_audio_manager_source_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
}


static void
sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_subscription_event_type_t t,
                                              guint32 index)
{
	pa_subscription_event_type_t source_type = 0;
	pa_subscription_event_type_t _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	source_type = t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK;
	_tmp0_ = source_type;
	switch (_tmp0_) {
		case PA_SUBSCRIPTION_EVENT_SINK:
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp1_;
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
			_tmp1_ = event_type;
			switch (_tmp1_) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_operation* _tmp2_;
					pa_operation* _tmp3_;
					_tmp2_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
					_tmp3_ = _tmp2_;
					_pa_operation_unref0 (_tmp3_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_operation* _tmp4_;
					pa_operation* _tmp5_;
					_tmp4_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
					_tmp5_ = _tmp4_;
					_pa_operation_unref0 (_tmp5_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					SoundDevice* device = NULL;
					GeeHashMap* _tmp6_;
					gpointer _tmp7_;
					SoundDevice* _tmp8_;
					_tmp6_ = self->priv->output_devices;
					_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, (gpointer) ((guintptr) index));
					device = (SoundDevice*) _tmp7_;
					_tmp8_ = device;
					if (_tmp8_ != NULL) {
						SoundDevice* _tmp9_;
						GeeHashMap* _tmp10_;
						_tmp9_ = device;
						g_signal_emit_by_name (_tmp9_, "removed");
						_tmp10_ = self->priv->output_devices;
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp10_, (gpointer) ((guintptr) index), NULL);
					}
					_g_object_unref0 (device);
					break;
				}
				default:
				break;
			}
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SERVER:
		{
			pa_context* _tmp11_;
			pa_operation* _tmp12_;
			pa_operation* _tmp13_;
			_tmp11_ = self->priv->_context;
			_tmp12_ = pa_context_get_server_info (_tmp11_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
			_tmp13_ = _tmp12_;
			_pa_operation_unref0 (_tmp13_);
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SOURCE:
		case PA_SUBSCRIPTION_EVENT_SOURCE_OUTPUT:
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp14_;
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
			_tmp14_ = event_type;
			switch (_tmp14_) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_operation* _tmp15_;
					pa_operation* _tmp16_;
					_tmp15_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
					_tmp16_ = _tmp15_;
					_pa_operation_unref0 (_tmp16_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_operation* _tmp17_;
					pa_operation* _tmp18_;
					_tmp17_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
					_tmp18_ = _tmp17_;
					_pa_operation_unref0 (_tmp18_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					SoundDevice* device = NULL;
					GeeHashMap* _tmp19_;
					gpointer _tmp20_;
					SoundDevice* _tmp21_;
					_tmp19_ = self->priv->input_devices;
					_tmp20_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, (gpointer) ((guintptr) index));
					device = (SoundDevice*) _tmp20_;
					_tmp21_ = device;
					if (_tmp21_ != NULL) {
						SoundDevice* _tmp22_;
						GeeHashMap* _tmp23_;
						_tmp22_ = device;
						g_signal_emit_by_name (_tmp22_, "removed");
						_tmp23_ = self->priv->input_devices;
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp23_, (gpointer) ((guintptr) index), NULL);
					}
					_g_object_unref0 (device);
					break;
				}
				default:
				break;
			}
			break;
		}
		default:
		break;
	}
}


static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->device);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}


static gboolean
__lambda6_ (Block2Data* _data2_,
            pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
	self = _data2_->self;
	g_return_val_if_fail (operation != NULL, FALSE);
	if (pa_operation_get_state (operation) != PA_OPERATION_RUNNING) {
		SoundDevice* _tmp0_;
		GeeLinkedList* _tmp1_;
		_tmp0_ = _data2_->device;
		_tmp1_ = _tmp0_->volume_operations;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, operation);
	}
	result = G_SOURCE_CONTINUE;
	_pa_operation_unref0 (operation);
	return result;
}


static gboolean
___lambda6__gee_forall_func (gpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda6_ (self, (pa_operation*) g);
	return result;
}


static void
sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                pa_context* c,
                                                pa_source_info* i,
                                                gint eol)
{
	Block2Data* _data2_;
	guint32 _tmp0_;
	gboolean is_new = FALSE;
	GeeHashMap* _tmp1_;
	guint32 _tmp2_;
	gboolean _tmp3_;
	SoundDevice* _tmp9_;
	SoundDevice* _tmp10_;
	const gchar* _tmp11_;
	SoundDevice* _tmp12_;
	const gchar* _tmp13_;
	SoundDevice* _tmp14_;
	gint _tmp15_;
	SoundDevice* _tmp16_;
	pa_cvolume _tmp17_;
	SoundDevice* _tmp18_;
	pa_channel_map _tmp19_;
	SoundDevice* _tmp20_;
	pa_channel_map _tmp21_;
	SoundDevice* _tmp22_;
	GeeLinkedList* _tmp23_;
	SoundDevice* _tmp24_;
	GeeArrayList* _tmp25_;
	GeeArrayList* _tmp26_;
	SoundDevice* _tmp27_;
	SoundDevice* _tmp60_;
	GeeLinkedList* _tmp61_;
	gboolean _tmp62_;
	gboolean _tmp63_;
	gchar* form_factor = NULL;
	pa_proplist* _tmp65_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
	const gchar* _tmp68_;
	SoundDevice* _tmp71_;
	const gchar* _tmp72_;
	const gchar* _tmp73_;
	SoundDevice* _tmp74_;
	gboolean _tmp75_;
	gboolean _tmp76_;
	gboolean _tmp78_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	if (i == NULL) {
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return;
	}
	_tmp0_ = (*i).monitor_of_sink;
	if (_tmp0_ != PA_INVALID_INDEX) {
		block2_data_unref (_data2_);
		_data2_ = NULL;
		return;
	}
	_data2_->device = NULL;
	_tmp1_ = self->priv->input_devices;
	_tmp2_ = (*i).index;
	is_new = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((guintptr) _tmp2_));
	_tmp3_ = is_new;
	if (_tmp3_) {
		guint32 _tmp4_;
		SoundDevice* _tmp5_;
		_tmp4_ = (*i).index;
		_tmp5_ = sound_device_new (_tmp4_);
		_g_object_unref0 (_data2_->device);
		_data2_->device = _tmp5_;
	} else {
		GeeHashMap* _tmp6_;
		guint32 _tmp7_;
		gpointer _tmp8_;
		_tmp6_ = self->priv->input_devices;
		_tmp7_ = (*i).index;
		_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, (gpointer) ((guintptr) _tmp7_));
		_g_object_unref0 (_data2_->device);
		_data2_->device = (SoundDevice*) _tmp8_;
	}
	_tmp9_ = _data2_->device;
	sound_device_set_input (_tmp9_, TRUE);
	_tmp10_ = _data2_->device;
	_tmp11_ = (*i).name;
	sound_device_set_name (_tmp10_, _tmp11_);
	_tmp12_ = _data2_->device;
	_tmp13_ = (*i).description;
	sound_device_set_display_name (_tmp12_, _tmp13_);
	_tmp14_ = _data2_->device;
	_tmp15_ = (*i).mute;
	sound_device_set_is_muted (_tmp14_, _tmp15_ != 0);
	_tmp16_ = _data2_->device;
	_tmp17_ = (*i).volume;
	sound_device_set_cvolume (_tmp16_, &_tmp17_);
	_tmp18_ = _data2_->device;
	_tmp19_ = (*i).channel_map;
	sound_device_set_channel_map (_tmp18_, &_tmp19_);
	_tmp20_ = _data2_->device;
	_tmp21_ = (*i).channel_map;
	sound_device_set_balance (_tmp20_, pa_cvolume_get_balance (&(*i).volume, &_tmp21_));
	_tmp22_ = _data2_->device;
	_tmp23_ = _tmp22_->volume_operations;
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp23_, ___lambda6__gee_forall_func, _data2_);
	_tmp24_ = _data2_->device;
	_tmp25_ = sound_device_get_ports (_tmp24_);
	_tmp26_ = _tmp25_;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp26_);
	_tmp27_ = _data2_->device;
	sound_device_set_default_port (_tmp27_, NULL);
	{
		gint idx = 0;
		idx = 0;
		{
			gboolean _tmp28_ = FALSE;
			_tmp28_ = TRUE;
			while (TRUE) {
				gint _tmp30_;
				guint32 _tmp31_;
				SoundDevicePort* new_port = NULL;
				SoundDevicePort* _tmp32_;
				SoundDevicePort* _tmp33_;
				pa_source_port_info** _tmp34_;
				gint _tmp34__length1;
				gint _tmp35_;
				pa_source_port_info* _tmp36_;
				const gchar* _tmp37_;
				gchar* _tmp38_;
				SoundDevicePort* _tmp39_;
				pa_source_port_info** _tmp40_;
				gint _tmp40__length1;
				gint _tmp41_;
				pa_source_port_info* _tmp42_;
				const gchar* _tmp43_;
				gchar* _tmp44_;
				SoundDevicePort* _tmp45_;
				pa_source_port_info** _tmp46_;
				gint _tmp46__length1;
				gint _tmp47_;
				pa_source_port_info* _tmp48_;
				guint32 _tmp49_;
				SoundDevice* _tmp50_;
				GeeArrayList* _tmp51_;
				GeeArrayList* _tmp52_;
				SoundDevicePort* _tmp53_;
				pa_source_port_info** _tmp54_;
				gint _tmp54__length1;
				gint _tmp55_;
				pa_source_port_info* _tmp56_;
				pa_source_port_info* _tmp57_;
				if (!_tmp28_) {
					gint _tmp29_;
					_tmp29_ = idx;
					idx = _tmp29_ + 1;
				}
				_tmp28_ = FALSE;
				_tmp30_ = idx;
				_tmp31_ = (*i).n_ports;
				if (!(((guint32) _tmp30_) < _tmp31_)) {
					break;
				}
				_tmp32_ = sound_device_port_new ();
				new_port = _tmp32_;
				_tmp33_ = new_port;
				_tmp34_ = (*i).ports;
				_tmp34__length1 = (*i).n_ports;
				_tmp35_ = idx;
				_tmp36_ = _tmp34_[_tmp35_];
				_tmp37_ = (*_tmp36_).name;
				_tmp38_ = g_strdup (_tmp37_);
				_g_free0 (_tmp33_->name);
				_tmp33_->name = _tmp38_;
				_tmp39_ = new_port;
				_tmp40_ = (*i).ports;
				_tmp40__length1 = (*i).n_ports;
				_tmp41_ = idx;
				_tmp42_ = _tmp40_[_tmp41_];
				_tmp43_ = (*_tmp42_).description;
				_tmp44_ = g_strdup (_tmp43_);
				_g_free0 (_tmp39_->description);
				_tmp39_->description = _tmp44_;
				_tmp45_ = new_port;
				_tmp46_ = (*i).ports;
				_tmp46__length1 = (*i).n_ports;
				_tmp47_ = idx;
				_tmp48_ = _tmp46_[_tmp47_];
				_tmp49_ = (*_tmp48_).priority;
				_tmp45_->priority = _tmp49_;
				_tmp50_ = _data2_->device;
				_tmp51_ = sound_device_get_ports (_tmp50_);
				_tmp52_ = _tmp51_;
				_tmp53_ = new_port;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp52_, _tmp53_);
				_tmp54_ = (*i).ports;
				_tmp54__length1 = (*i).n_ports;
				_tmp55_ = idx;
				_tmp56_ = _tmp54_[_tmp55_];
				_tmp57_ = (*i).active_port;
				if (_tmp56_ == _tmp57_) {
					SoundDevice* _tmp58_;
					SoundDevicePort* _tmp59_;
					_tmp58_ = _data2_->device;
					_tmp59_ = new_port;
					sound_device_set_default_port (_tmp58_, _tmp59_);
				}
				_sound_device_port_unref0 (new_port);
			}
		}
	}
	_tmp60_ = _data2_->device;
	_tmp61_ = _tmp60_->volume_operations;
	_tmp62_ = gee_collection_get_is_empty ((GeeCollection*) _tmp61_);
	_tmp63_ = _tmp62_;
	if (_tmp63_) {
		SoundDevice* _tmp64_;
		_tmp64_ = _data2_->device;
		sound_device_set_volume (_tmp64_, sound_pulse_audio_manager_volume_to_double (pa_cvolume_max (&(*i).volume)));
	}
	_tmp65_ = (*i).proplist;
	_tmp66_ = pa_proplist_gets (_tmp65_, PA_PROP_DEVICE_FORM_FACTOR);
	_tmp67_ = g_strdup (_tmp66_);
	form_factor = _tmp67_;
	_tmp68_ = form_factor;
	if (_tmp68_ != NULL) {
		SoundDevice* _tmp69_;
		const gchar* _tmp70_;
		_tmp69_ = _data2_->device;
		_tmp70_ = form_factor;
		sound_device_set_form_factor (_tmp69_, _tmp70_);
	}
	_tmp71_ = _data2_->device;
	_tmp72_ = (*i).name;
	_tmp73_ = self->priv->default_source_name;
	sound_device_set_is_default (_tmp71_, g_strcmp0 (_tmp72_, _tmp73_) == 0);
	_tmp74_ = _data2_->device;
	_tmp75_ = sound_device_get_is_default (_tmp74_);
	_tmp76_ = _tmp75_;
	if (_tmp76_) {
		SoundDevice* _tmp77_;
		_tmp77_ = _data2_->device;
		sound_pulse_audio_manager_set_default_input (self, _tmp77_);
	}
	_tmp78_ = is_new;
	if (_tmp78_) {
		GeeHashMap* _tmp79_;
		guint32 _tmp80_;
		SoundDevice* _tmp81_;
		SoundDevice* _tmp82_;
		_tmp79_ = self->priv->input_devices;
		_tmp80_ = (*i).index;
		_tmp81_ = _data2_->device;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp79_, (gpointer) ((guintptr) _tmp80_), _tmp81_);
		_tmp82_ = _data2_->device;
		g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp82_);
	}
	_g_free0 (form_factor);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		SoundPulseAudioManager* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->device);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}


static gboolean
__lambda5_ (Block3Data* _data3_,
            pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
	self = _data3_->self;
	g_return_val_if_fail (operation != NULL, FALSE);
	if (pa_operation_get_state (operation) != PA_OPERATION_RUNNING) {
		SoundDevice* _tmp0_;
		GeeLinkedList* _tmp1_;
		_tmp0_ = _data3_->device;
		_tmp1_ = _tmp0_->volume_operations;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, operation);
	}
	result = G_SOURCE_CONTINUE;
	_pa_operation_unref0 (operation);
	return result;
}


static gboolean
___lambda5__gee_forall_func (gpointer g,
                             gpointer self)
{
	gboolean result;
	result = __lambda5_ (self, (pa_operation*) g);
	return result;
}


static void
sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_sink_info* i,
                                              gint eol)
{
	Block3Data* _data3_;
	gboolean is_new = FALSE;
	GeeHashMap* _tmp0_;
	guint32 _tmp1_;
	gboolean _tmp2_;
	SoundDevice* _tmp8_;
	SoundDevice* _tmp9_;
	const gchar* _tmp10_;
	SoundDevice* _tmp11_;
	const gchar* _tmp12_;
	SoundDevice* _tmp13_;
	gint _tmp14_;
	SoundDevice* _tmp15_;
	pa_cvolume _tmp16_;
	SoundDevice* _tmp17_;
	pa_channel_map _tmp18_;
	SoundDevice* _tmp19_;
	pa_channel_map _tmp20_;
	SoundDevice* _tmp21_;
	GeeLinkedList* _tmp22_;
	SoundDevice* _tmp23_;
	GeeArrayList* _tmp24_;
	GeeArrayList* _tmp25_;
	SoundDevice* _tmp26_;
	SoundDevice* _tmp59_;
	GeeLinkedList* _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	gchar* form_factor = NULL;
	pa_proplist* _tmp64_;
	const gchar* _tmp65_;
	gchar* _tmp66_;
	const gchar* _tmp67_;
	SoundDevice* _tmp70_;
	const gchar* _tmp71_;
	const gchar* _tmp72_;
	SoundDevice* _tmp73_;
	gboolean _tmp74_;
	gboolean _tmp75_;
	gboolean _tmp77_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	if (i == NULL) {
		block3_data_unref (_data3_);
		_data3_ = NULL;
		return;
	}
	_data3_->device = NULL;
	_tmp0_ = self->priv->output_devices;
	_tmp1_ = (*i).index;
	is_new = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, (gpointer) ((guintptr) _tmp1_));
	_tmp2_ = is_new;
	if (_tmp2_) {
		guint32 _tmp3_;
		SoundDevice* _tmp4_;
		_tmp3_ = (*i).index;
		_tmp4_ = sound_device_new (_tmp3_);
		_g_object_unref0 (_data3_->device);
		_data3_->device = _tmp4_;
	} else {
		GeeHashMap* _tmp5_;
		guint32 _tmp6_;
		gpointer _tmp7_;
		_tmp5_ = self->priv->output_devices;
		_tmp6_ = (*i).index;
		_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((guintptr) _tmp6_));
		_g_object_unref0 (_data3_->device);
		_data3_->device = (SoundDevice*) _tmp7_;
	}
	_tmp8_ = _data3_->device;
	sound_device_set_input (_tmp8_, FALSE);
	_tmp9_ = _data3_->device;
	_tmp10_ = (*i).name;
	sound_device_set_name (_tmp9_, _tmp10_);
	_tmp11_ = _data3_->device;
	_tmp12_ = (*i).description;
	sound_device_set_display_name (_tmp11_, _tmp12_);
	_tmp13_ = _data3_->device;
	_tmp14_ = (*i).mute;
	sound_device_set_is_muted (_tmp13_, _tmp14_ != 0);
	_tmp15_ = _data3_->device;
	_tmp16_ = (*i).volume;
	sound_device_set_cvolume (_tmp15_, &_tmp16_);
	_tmp17_ = _data3_->device;
	_tmp18_ = (*i).channel_map;
	sound_device_set_channel_map (_tmp17_, &_tmp18_);
	_tmp19_ = _data3_->device;
	_tmp20_ = (*i).channel_map;
	sound_device_set_balance (_tmp19_, pa_cvolume_get_balance (&(*i).volume, &_tmp20_));
	_tmp21_ = _data3_->device;
	_tmp22_ = _tmp21_->volume_operations;
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp22_, ___lambda5__gee_forall_func, _data3_);
	_tmp23_ = _data3_->device;
	_tmp24_ = sound_device_get_ports (_tmp23_);
	_tmp25_ = _tmp24_;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp25_);
	_tmp26_ = _data3_->device;
	sound_device_set_default_port (_tmp26_, NULL);
	{
		gint idx = 0;
		idx = 0;
		{
			gboolean _tmp27_ = FALSE;
			_tmp27_ = TRUE;
			while (TRUE) {
				gint _tmp29_;
				guint32 _tmp30_;
				SoundDevicePort* new_port = NULL;
				SoundDevicePort* _tmp31_;
				SoundDevicePort* _tmp32_;
				pa_sink_port_info** _tmp33_;
				gint _tmp33__length1;
				gint _tmp34_;
				pa_sink_port_info* _tmp35_;
				const gchar* _tmp36_;
				gchar* _tmp37_;
				SoundDevicePort* _tmp38_;
				pa_sink_port_info** _tmp39_;
				gint _tmp39__length1;
				gint _tmp40_;
				pa_sink_port_info* _tmp41_;
				const gchar* _tmp42_;
				gchar* _tmp43_;
				SoundDevicePort* _tmp44_;
				pa_sink_port_info** _tmp45_;
				gint _tmp45__length1;
				gint _tmp46_;
				pa_sink_port_info* _tmp47_;
				guint32 _tmp48_;
				SoundDevice* _tmp49_;
				GeeArrayList* _tmp50_;
				GeeArrayList* _tmp51_;
				SoundDevicePort* _tmp52_;
				pa_sink_port_info** _tmp53_;
				gint _tmp53__length1;
				gint _tmp54_;
				pa_sink_port_info* _tmp55_;
				pa_sink_port_info* _tmp56_;
				if (!_tmp27_) {
					gint _tmp28_;
					_tmp28_ = idx;
					idx = _tmp28_ + 1;
				}
				_tmp27_ = FALSE;
				_tmp29_ = idx;
				_tmp30_ = (*i).n_ports;
				if (!(((guint32) _tmp29_) < _tmp30_)) {
					break;
				}
				_tmp31_ = sound_device_port_new ();
				new_port = _tmp31_;
				_tmp32_ = new_port;
				_tmp33_ = (*i).ports;
				_tmp33__length1 = (*i).n_ports;
				_tmp34_ = idx;
				_tmp35_ = _tmp33_[_tmp34_];
				_tmp36_ = (*_tmp35_).name;
				_tmp37_ = g_strdup (_tmp36_);
				_g_free0 (_tmp32_->name);
				_tmp32_->name = _tmp37_;
				_tmp38_ = new_port;
				_tmp39_ = (*i).ports;
				_tmp39__length1 = (*i).n_ports;
				_tmp40_ = idx;
				_tmp41_ = _tmp39_[_tmp40_];
				_tmp42_ = (*_tmp41_).description;
				_tmp43_ = g_strdup (_tmp42_);
				_g_free0 (_tmp38_->description);
				_tmp38_->description = _tmp43_;
				_tmp44_ = new_port;
				_tmp45_ = (*i).ports;
				_tmp45__length1 = (*i).n_ports;
				_tmp46_ = idx;
				_tmp47_ = _tmp45_[_tmp46_];
				_tmp48_ = (*_tmp47_).priority;
				_tmp44_->priority = _tmp48_;
				_tmp49_ = _data3_->device;
				_tmp50_ = sound_device_get_ports (_tmp49_);
				_tmp51_ = _tmp50_;
				_tmp52_ = new_port;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp51_, _tmp52_);
				_tmp53_ = (*i).ports;
				_tmp53__length1 = (*i).n_ports;
				_tmp54_ = idx;
				_tmp55_ = _tmp53_[_tmp54_];
				_tmp56_ = (*i).active_port;
				if (_tmp55_ == _tmp56_) {
					SoundDevice* _tmp57_;
					SoundDevicePort* _tmp58_;
					_tmp57_ = _data3_->device;
					_tmp58_ = new_port;
					sound_device_set_default_port (_tmp57_, _tmp58_);
				}
				_sound_device_port_unref0 (new_port);
			}
		}
	}
	_tmp59_ = _data3_->device;
	_tmp60_ = _tmp59_->volume_operations;
	_tmp61_ = gee_collection_get_is_empty ((GeeCollection*) _tmp60_);
	_tmp62_ = _tmp61_;
	if (_tmp62_) {
		SoundDevice* _tmp63_;
		_tmp63_ = _data3_->device;
		sound_device_set_volume (_tmp63_, sound_pulse_audio_manager_volume_to_double (pa_cvolume_max (&(*i).volume)));
	}
	_tmp64_ = (*i).proplist;
	_tmp65_ = pa_proplist_gets (_tmp64_, PA_PROP_DEVICE_FORM_FACTOR);
	_tmp66_ = g_strdup (_tmp65_);
	form_factor = _tmp66_;
	_tmp67_ = form_factor;
	if (_tmp67_ != NULL) {
		SoundDevice* _tmp68_;
		const gchar* _tmp69_;
		_tmp68_ = _data3_->device;
		_tmp69_ = form_factor;
		sound_device_set_form_factor (_tmp68_, _tmp69_);
	}
	_tmp70_ = _data3_->device;
	_tmp71_ = (*i).name;
	_tmp72_ = self->priv->default_sink_name;
	sound_device_set_is_default (_tmp70_, g_strcmp0 (_tmp71_, _tmp72_) == 0);
	_tmp73_ = _data3_->device;
	_tmp74_ = sound_device_get_is_default (_tmp73_);
	_tmp75_ = _tmp74_;
	if (_tmp75_) {
		SoundDevice* _tmp76_;
		_tmp76_ = _data3_->device;
		sound_pulse_audio_manager_set_default_output (self, _tmp76_);
	}
	_tmp77_ = is_new;
	if (_tmp77_) {
		GeeHashMap* _tmp78_;
		guint32 _tmp79_;
		SoundDevice* _tmp80_;
		SoundDevice* _tmp81_;
		_tmp78_ = self->priv->output_devices;
		_tmp79_ = (*i).index;
		_tmp80_ = _data3_->device;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp78_, (gpointer) ((guintptr) _tmp79_), _tmp80_);
		_tmp81_ = _data3_->device;
		g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp81_);
	}
	_g_free0 (form_factor);
	block3_data_unref (_data3_);
	_data3_ = NULL;
}


static void
sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                pa_context* c,
                                                pa_server_info* i)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	pa_context* _tmp4_;
	pa_operation* _tmp5_;
	pa_operation* _tmp6_;
	pa_context* _tmp7_;
	pa_operation* _tmp8_;
	pa_operation* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i == NULL) {
		return;
	}
	_tmp0_ = (*i).default_source_name;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->default_source_name);
	self->priv->default_source_name = _tmp1_;
	_tmp2_ = (*i).default_sink_name;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (self->priv->default_sink_name);
	self->priv->default_sink_name = _tmp3_;
	_tmp4_ = self->priv->_context;
	_tmp5_ = pa_context_get_sink_info_list (_tmp4_, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
	_tmp6_ = _tmp5_;
	_pa_operation_unref0 (_tmp6_);
	_tmp7_ = self->priv->_context;
	_tmp8_ = pa_context_get_source_info_list (_tmp7_, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
	_tmp9_ = _tmp8_;
	_pa_operation_unref0 (_tmp9_);
}


static void
sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                 pa_context* c,
                                                                 pa_ext_stream_restore_info* info,
                                                                 gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	gchar* _tmp3_;
	pa_channel_map _tmp4_;
	pa_cvolume _tmp5_;
	gint _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	pa_ext_stream_restore_info _tmp9_;
	pa_ext_stream_restore_info* _tmp10_;
	pa_ext_stream_restore_info* _tmp11_;
	gint _tmp11__length1;
	pa_operation* _tmp12_;
	pa_operation* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (eol != 0) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp1_;
		_tmp1_ = (*info).name;
		_tmp0_ = !g_str_has_prefix (_tmp1_, "sink-input-by");
	}
	if (_tmp0_) {
		return;
	}
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
	_tmp2_ = (*info).name;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (new_info.name);
	new_info.name = _tmp3_;
	_tmp4_ = (*info).channel_map;
	new_info.channel_map = _tmp4_;
	_tmp5_ = (*info).volume;
	new_info.volume = _tmp5_;
	_tmp6_ = (*info).mute;
	new_info.mute = _tmp6_;
	_tmp7_ = self->priv->default_sink_name;
	_tmp8_ = g_strdup (_tmp7_);
	_g_free0 (new_info.device);
	new_info.device = _tmp8_;
	_tmp9_ = new_info;
	_tmp10_ = g_new0 (pa_ext_stream_restore_info, 1);
	_tmp10_[0] = _tmp9_;
	_tmp11_ = _tmp10_;
	_tmp11__length1 = 1;
	_tmp12_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp11_, 1, 1, NULL, NULL);
	_tmp13_ = _tmp12_;
	_pa_operation_unref0 (_tmp13_);
	_tmp11_ = (g_free (_tmp11_), NULL);
	 (&new_info);
}


static void
sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                   pa_context* c,
                                                                   pa_ext_stream_restore_info* info,
                                                                   gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	gchar* _tmp3_;
	pa_channel_map _tmp4_;
	pa_cvolume _tmp5_;
	gint _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	pa_ext_stream_restore_info _tmp9_;
	pa_ext_stream_restore_info* _tmp10_;
	pa_ext_stream_restore_info* _tmp11_;
	gint _tmp11__length1;
	pa_operation* _tmp12_;
	pa_operation* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (eol != 0) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp1_;
		_tmp1_ = (*info).name;
		_tmp0_ = !g_str_has_prefix (_tmp1_, "source-output-by");
	}
	if (_tmp0_) {
		return;
	}
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
	_tmp2_ = (*info).name;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (new_info.name);
	new_info.name = _tmp3_;
	_tmp4_ = (*info).channel_map;
	new_info.channel_map = _tmp4_;
	_tmp5_ = (*info).volume;
	new_info.volume = _tmp5_;
	_tmp6_ = (*info).mute;
	new_info.mute = _tmp6_;
	_tmp7_ = self->priv->default_source_name;
	_tmp8_ = g_strdup (_tmp7_);
	_g_free0 (new_info.device);
	new_info.device = _tmp8_;
	_tmp9_ = new_info;
	_tmp10_ = g_new0 (pa_ext_stream_restore_info, 1);
	_tmp10_[0] = _tmp9_;
	_tmp11_ = _tmp10_;
	_tmp11__length1 = 1;
	_tmp12_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp11_, 1, 1, NULL, NULL);
	_tmp13_ = _tmp12_;
	_pa_operation_unref0 (_tmp13_);
	_tmp11_ = (g_free (_tmp11_), NULL);
	 (&new_info);
}


static gdouble
sound_pulse_audio_manager_volume_to_double (pa_volume_t vol)
{
	gdouble result = 0.0;
	gdouble tmp = 0.0;
	tmp = (gdouble) (vol - PA_VOLUME_MUTED);
	result = (100 * tmp) / ((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED));
	return result;
}


static pa_volume_t
sound_pulse_audio_manager_double_to_volume (gdouble vol)
{
	pa_volume_t result = 0U;
	gdouble tmp = 0.0;
	tmp = (((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED)) * vol) / 100;
	result = ((pa_volume_t) tmp) + PA_VOLUME_MUTED;
	return result;
}


pa_context*
sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self)
{
	pa_context* result;
	pa_context* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_context;
	result = _tmp0_;
	return result;
}


static gpointer
_pa_context_ref0 (gpointer self)
{
	return self ? pa_context_ref (self) : NULL;
}


static void
sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self,
                                       pa_context* value)
{
	g_return_if_fail (self != NULL);
	if (sound_pulse_audio_manager_get_context (self) != value) {
		pa_context* _tmp0_;
		_tmp0_ = _pa_context_ref0 (value);
		_pa_context_unref0 (self->priv->_context);
		self->priv->_context = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY]);
	}
}


SoundDevice*
sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_output;
	result = _tmp0_;
	return result;
}


static void
sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                              SoundDevice* value)
{
	g_return_if_fail (self != NULL);
	if (sound_pulse_audio_manager_get_default_output (self) != value) {
		SoundDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_default_output);
		self->priv->_default_output = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY]);
	}
}


SoundDevice*
sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_input;
	result = _tmp0_;
	return result;
}


static void
sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                             SoundDevice* value)
{
	g_return_if_fail (self != NULL);
	if (sound_pulse_audio_manager_get_default_input (self) != value) {
		SoundDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_default_input);
		self->priv->_default_input = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY]);
	}
}


static GObject *
sound_pulse_audio_manager_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundPulseAudioManager * self;
	pa_glib_mainloop* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	parent_class = G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	_tmp0_ = pa_glib_mainloop_new (NULL);
	_pa_glib_mainloop_free0 (self->priv->loop);
	self->priv->loop = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->input_devices);
	self->priv->input_devices = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->output_devices);
	self->priv->output_devices = _tmp2_;
	_tmp3_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_POINTER, (GBoxedCopyFunc) pa_operation_ref, (GDestroyNotify) pa_operation_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->volume_operations);
	self->priv->volume_operations = _tmp3_;
	return obj;
}


static void
sound_pulse_audio_manager_class_init (SoundPulseAudioManagerClass * klass)
{
	sound_pulse_audio_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SoundPulseAudioManagerPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_pulse_audio_manager_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_pulse_audio_manager_set_property;
	G_OBJECT_CLASS (klass)->constructor = sound_pulse_audio_manager_constructor;
	G_OBJECT_CLASS (klass)->finalize = sound_pulse_audio_manager_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY] = g_param_spec_pointer ("context", "context", "context", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY] = g_param_spec_object ("default-output", "default-output", "default-output", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY] = g_param_spec_object ("default-input", "default-input", "default-input", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL] = g_signal_new ("new-device", SOUND_TYPE_PULSE_AUDIO_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SOUND_TYPE_DEVICE);
}


static void
sound_pulse_audio_manager_instance_init (SoundPulseAudioManager * self)
{
	self->priv = SOUND_PULSE_AUDIO_MANAGER_GET_PRIVATE (self);
	self->priv->is_ready = FALSE;
	self->priv->reconnect_timer_id = 0U;
}


static void
sound_pulse_audio_manager_finalize (GObject * obj)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	_pa_context_unref0 (self->priv->_context);
	_pa_glib_mainloop_free0 (self->priv->loop);
	_g_object_unref0 (self->priv->input_devices);
	_g_object_unref0 (self->priv->output_devices);
	_g_object_unref0 (self->priv->_default_output);
	_g_object_unref0 (self->priv->_default_input);
	_g_free0 (self->priv->default_source_name);
	_g_free0 (self->priv->default_sink_name);
	_g_object_unref0 (self->priv->volume_operations);
	G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class)->finalize (obj);
}


GType
sound_pulse_audio_manager_get_type (void)
{
	static volatile gsize sound_pulse_audio_manager_type_id__volatile = 0;
	if (g_once_init_enter (&sound_pulse_audio_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SoundPulseAudioManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_pulse_audio_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPulseAudioManager), 0, (GInstanceInitFunc) sound_pulse_audio_manager_instance_init, NULL };
		GType sound_pulse_audio_manager_type_id;
		sound_pulse_audio_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundPulseAudioManager", &g_define_type_info, 0);
		g_once_init_leave (&sound_pulse_audio_manager_type_id__volatile, sound_pulse_audio_manager_type_id);
	}
	return sound_pulse_audio_manager_type_id__volatile;
}


static void
_vala_sound_pulse_audio_manager_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	switch (property_id) {
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
		g_value_set_pointer (value, sound_pulse_audio_manager_get_context (self));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
		g_value_set_object (value, sound_pulse_audio_manager_get_default_output (self));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
		g_value_set_object (value, sound_pulse_audio_manager_get_default_input (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_sound_pulse_audio_manager_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
	switch (property_id) {
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
		sound_pulse_audio_manager_set_context (self, g_value_get_pointer (value));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
		sound_pulse_audio_manager_set_default_output (self, g_value_get_object (value));
		break;
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
		sound_pulse_audio_manager_set_default_input (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



